/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: DefaultObservationSetVisitor.java,v cb24a43dcaf0 2010/04/29 21:32:27 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.observation;

import javax.annotation.Nonnull;
import it.tidalwave.bluebill.observation.Observation;
import it.tidalwave.bluebill.observation.ObservationItem;
import it.tidalwave.bluebill.observation.ObservationSet;
import static it.tidalwave.bluebill.observation.Observation.Observation;

/***********************************************************************************************************************
 *
 * FIXME: move to the Observation API
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class DefaultObservationSetVisitor implements ObservationSetVisitor
  {
    @Nonnull
    private final ObservationSet observationSet;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public DefaultObservationSetVisitor (final @Nonnull ObservationSet observationSet)
      {
        this.observationSet = observationSet;
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public <T extends Listener> T visit (final @Nonnull T listener)
      {
        listener.begin();

        for (final Observation observation : observationSet.find(Observation).results())
          {
            listener.beginVisit(observation);

            for (final ObservationItem item : observation.findObservationItems().results())
              {
                listener.visit(item);
              }

            listener.endVisit(observation);
          }

        listener.end();
        
        return listener;
      }
  }
