/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: ObservationSetVisitor.java,v cb24a43dcaf0 2010/04/29 21:32:27 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.observation;

import javax.annotation.Nonnull;
import it.tidalwave.bluebill.observation.Observation;
import it.tidalwave.bluebill.observation.ObservationItem;

/***********************************************************************************************************************
 *
 * FIXME: move to the Observation API (as ObservationSet.Visitor)
 *
 * @author  Fabrizio Giudici
 * @version $Id:$
 *
 **********************************************************************************************************************/
public interface ObservationSetVisitor
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public static interface Listener
      {
        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void begin();

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void end();
        
        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void beginVisit (@Nonnull Observation observation);

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void endVisit (@Nonnull Observation observation);

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void visit (@Nonnull ObservationItem item);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public <T extends Listener> T visit (@Nonnull T listener);
  }
